#if !CAN_API_FILE_HEADER_INCLUDE
#define CAN_API_FILE_HEADER_INCLUDE

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct can_api;
struct can_api_send_thread
{
	HANDLE hThread;
	unsigned long dwDelay;	// Delay fr Hintergrundthread
	ISRInfo isrCAN;
	struct can_api *pMain;
	int id;
	int stop;
	struct can_api_send_thread *pNext;
};

struct can_api
{
	HANDLE hDevice;
	HWND hWnd;
	HANDLE hThread; // Hauptthread (behandelt alle hereinkommenden Nachrichten des Treibers)
	HANDLE hBusLoadThread; // Thread zur Berechnung der Buslast (1 mal pro Sekunde)
	volatile int iStopThread;
	HANDLE hSignal;
	int iMode; // 0=CAN 2.0A  1=CAN 2.0B
	int iFormat; // 0=11 Bit  1=29 Bit
	int dwTimeMultiplier; // die diversen Betriebssysteme haben unterschiedliche Auflsungen
	int iShowMessages;
	void *pUserData;
	unsigned long dwAccessCode;
	unsigned long dwAccessMask;
	unsigned long dwBaudrate;
	unsigned long dwDataLost; // Verlorene Messages beim Empfang
	unsigned long dwOldTime; // Zur Berechnung der Differenz zwischen zwei Botschaften
	unsigned long dwStartTime; // Startzeit (wird in OpenCan() festgestellt)
	volatile double statistikTime;
	volatile unsigned long statistikBits;
	volatile double statistikBusload;
	CANPARINFO info;
	int (*events)(struct can_api* c, double absTime, double relTime, ISRInfo *i);
	struct can_api_send_thread *pThread;
};

/*
int ExampleOfEvents(struct can_api* c, double absTime, double relTime, ISRInfo *i)
{
	switch (i->msg)
	{
	case EV2PRG_RECEIVED:
		break;
	case EV2PRG_TRANSMIT:
		break;
	case EV2PRG_ERROR: // wird nicht mehr aufgerufen, wird intern im Treiber bearbeitet
		break;
	case EV2PRG_BUSERROR:
		break;
	case EV2PRG_WARNING:
		break;
	case EV2PRG_PASSIVE:
		break;
	case EV2PRG_ARBITRATION:
		break;
	case EV2PRG_WAKEUP:
		break;
	case EV2PRG_OVERRUN:
		break;
	}
	return 0;
}
*/

extern struct can_api *canInit(HWND hParent, const void *pUserData,int (*events)(struct can_api* c, double absTime, double relTime, ISRInfo *i));
extern void canDeInit(struct can_api *c);
extern int canOpenDevice(struct can_api *c, const char *pDevName, int mode, int format, DWORD *pErr);
extern void canCloseDevice(struct can_api *c);
extern void canExtendedFrames(struct can_api *c, int format);
extern unsigned char canGetRegisterRR1(struct can_api *c, unsigned char nIndex);
extern void canSetRegisterRR1(struct can_api *c, unsigned char nIndex, unsigned char nNewValue);
extern unsigned char canGetRegister(struct can_api *c, unsigned char nIndex);
extern void canSetRegister(struct can_api *c, unsigned char nIndex, unsigned char nNewValue);
extern int canTransmitDataByISR(struct can_api *c, struct ISRInfo *isr);
extern int canTransmitData(struct can_api *c, unsigned long id, int rtr, int dlc, unsigned char* data);
extern unsigned char canGetSJA1000Status(struct can_api *c);
extern int canSetSJA1000Command(struct can_api *c, unsigned char command);
extern int canAcceptanceCodeMask(struct can_api *c, unsigned long code, unsigned long mask);
extern int canSetBaudrate(struct can_api *c, unsigned long baudrate);
extern void canResetTime(struct can_api *c);
extern long canGetTime(struct can_api *c);
extern long canGetLostDataMsg(struct can_api *c);
extern double canGetBusLoad(struct can_api *c);
extern void canSetLostDataMsg(struct can_api *c, long nNewValue);
extern void canShowMessages(struct can_api *c, int on_off);
extern int canDeleteTransmitThread(struct can_api *c, int threadId);
extern void canDeleteAllTransmitThreads(struct can_api *c);
extern int canAddTransmitThread(struct can_api *c, int threadId, unsigned long canId, int rtr, int dlc, unsigned char *data, unsigned long delay);


#endif // CAN_API_FILE_HEADER_INCLUDE
