#if !CANPAR_FILE_HEADER_INCLUDE
#define CANPAR_FILE_HEADER_INCLUDE

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* CanPar - Treiber


   Diese Datei ist fr alle Betriebssysteme!

*/

// Version (zur Versionskontrolle)
// Die Nummer wird erhht wenn es zu inkompatibilitten kommt
#define CANPAR_VERSION 4






// DeviceIOControl-Codes fr NT4 und fr Win9x
// Dadurch kann das ActiveX unter beiden Betriebssystemen verwendet werden
#ifndef CAN_DRIVER_FOR_LINUX

#define FILE_DEVICE_CANPAR FILE_DEVICE_PARALLEL_PORT
#define IOCTL_IO_1   CTL_CODE(FILE_DEVICE_CANPAR, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_2   CTL_CODE(FILE_DEVICE_CANPAR, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_3   CTL_CODE(FILE_DEVICE_CANPAR, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_4   CTL_CODE(FILE_DEVICE_CANPAR, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_5   CTL_CODE(FILE_DEVICE_CANPAR, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
//#define IOCTL_IO_6   CTL_CODE(FILE_DEVICE_CANPAR, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_7   CTL_CODE(FILE_DEVICE_CANPAR, 0x807, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_8   CTL_CODE(FILE_DEVICE_CANPAR, 0x808, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_9   CTL_CODE(FILE_DEVICE_CANPAR, 0x809, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_10  CTL_CODE(FILE_DEVICE_CANPAR, 0x810, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_11  CTL_CODE(FILE_DEVICE_CANPAR, 0x811, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_12  CTL_CODE(FILE_DEVICE_CANPAR, 0x812, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_13  CTL_CODE(FILE_DEVICE_CANPAR, 0x813, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_14  CTL_CODE(FILE_DEVICE_CANPAR, 0x814, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_15  CTL_CODE(FILE_DEVICE_CANPAR, 0x815, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_IO_16  CTL_CODE(FILE_DEVICE_CANPAR, 0x816, METHOD_BUFFERED, FILE_ANY_ACCESS)

#else


#define CANPAR_IOC_MAGIC 'j'

#define IOCTL_IO_1   _IO(CANPAR_IOC_MAGIC, 1)
#define IOCTL_IO_2   _IO(CANPAR_IOC_MAGIC, 2)
#define IOCTL_IO_3   _IO(CANPAR_IOC_MAGIC, 3)
#define IOCTL_IO_4   _IO(CANPAR_IOC_MAGIC, 4)
#define IOCTL_IO_5   _IO(CANPAR_IOC_MAGIC, 5)
#define IOCTL_IO_7   _IO(CANPAR_IOC_MAGIC, 7)
#define IOCTL_IO_8   _IO(CANPAR_IOC_MAGIC, 8)
#define IOCTL_IO_9   _IO(CANPAR_IOC_MAGIC, 9)
#define IOCTL_IO_10  _IO(CANPAR_IOC_MAGIC, 10)
#define IOCTL_IO_11  _IO(CANPAR_IOC_MAGIC, 11)
#define IOCTL_IO_12  _IO(CANPAR_IOC_MAGIC, 12)
#define IOCTL_IO_13  _IO(CANPAR_IOC_MAGIC, 13)
#define IOCTL_IO_14  _IO(CANPAR_IOC_MAGIC, 14)
#define IOCTL_IO_15  _IO(CANPAR_IOC_MAGIC, 15)
#define IOCTL_IO_16  _IO(CANPAR_IOC_MAGIC, 16)

struct ioctlTransfer
{
	void   *lpvInBuffer;			// Datenbergabe ber IOControl
	int		cbInBuffer;
	void   *lpvOutBuffer;
	int		cbOutBuffer;
	int		cbBytesReturned;
};
#endif


// Kommandos (neu fr IOCTL16)
// Verwendbar im BASIC-CAN Modus
#define CAN_COMMAND_STANDBY 1
#define CAN_COMMAND_ABORT_TRANSMISSION 2
#define CAN_COMMAND_CLEAR_OVERRUN 3
#define CAN_COMMAND_STANDBY_OFF 4
// Verwendbar im PELICAN-CAN Modus
#define CAN_COMMAND_SELF_RECEPTION_REQUEST 0x80
#define CAN_COMMAND_LISTEN_ON 0x81
#define CAN_COMMAND_LISTEN_OFF 0x82

// Strukturen die zwischen Applikation und Treiber verwendet werden
typedef struct HighLow  
{
	unsigned long low;
	unsigned long high;
}HIGHLOW;


#define EV2PRG_ERROR 1 /* diese Botschaft wird nicht mehr gesendet ! */
#define EV2PRG_RECEIVED 2
#define EV2PRG_TRANSMIT 3
#define EV2PRG_BUSERROR 4
#define EV2PRG_OVERRUN 5
#define EV2PRG_WAKEUP 6

// neu fr PELICAN-Modus
#define EV2PRG_WARNING 7
#define EV2PRG_PASSIVE 8
#define EV2PRG_ARBITRATION 9

// neu fr Demo
#define EV2PRG_BAUDRATE_DEMO 10      /* Baudraten > 400 kBaud knnen in der DEMO nicht eingestellt werden */


struct ISRInfo
{
	//unsigned long	refData;		// Parameter, der von der Applikation bergeben wurde (Zeiger auf Instanz der Klasse)
	unsigned long   msg;			// siehe EV2PRG_...
	HIGHLOW			timeStamp;		// Zeitmarke (64 Bit; 0.8 s Auflsung)
	unsigned long	canIdentifier;
	unsigned long	lost;			// Verlorene Botschaften (zwischen der aktuellen und der zuletzt in der Applikation empfangenen)
	unsigned char	canRTR;			// ???
	unsigned char	canDLC;			
	unsigned char	status;			// Statusbyte aus SJL1000
	char			intern;			// 1=Karte wurde rckgesetzt (Spannung aus/ein)
	short			isrNummer;		// Nummer zum freigeben der Struktur nach Bearbeitung
	unsigned char	canMsg[8];		// eine CAN-Botschaft kann maximal 8 Bytes enthalten
};

typedef struct InitISRFunctions
{
	unsigned long	pCallback;
	unsigned long	refData;
}INITISRFUNCTIONS;



#define OS_WINDOWS9x  1
#define OS_WINDOWSNT4 2
#define OS_WINDOWS2K  3
#define OS_LINUX      4


#define TIME_DIVIDER_WIN9X  (1250)		/* Win9x Auflsung: 0.8 s */
#define TIME_DIVIDER_WINNT4 (1250*8)   /* Win NT 4.0 Auflsung: 0.1 s */

typedef struct CanParInfo
{
	unsigned long	version;		// ActiveX und Treiber mssen zusammenpassen !! (Versionskontrolle)
	HIGHLOW			time;			// Zeitmarke (64-Bit Wert)
	unsigned char   card;			// 1=ELEKTOR parallel
	unsigned char   os;				// Betriebssystem (siehe OS_....)
}CANPARINFO;

#endif
