// VCanParD


#define CANPAR_VERSION 3

#define IOCTL_IO_1   1
#define IOCTL_IO_2   2
#define IOCTL_IO_3   3
#define IOCTL_IO_4   4
#define IOCTL_IO_5   5
#define IOCTL_IO_6   6
#define IOCTL_IO_7   7
#define IOCTL_IO_8   8
#define IOCTL_IO_9   9
#define IOCTL_IO_10  10
#define IOCTL_IO_11  11
#define IOCTL_IO_12  12

typedef unsigned long DWORD;
typedef int BOOL;
typedef unsigned char uchar;
#define FALSE 0
#define TRUE 1

typedef struct HighLow  
{
	unsigned long low;
	unsigned long high;
}HIGHLOW;


struct ISRInfo
{
	DWORD			refData;		// Parameter, der von der Applikation bergeben wurde (Zeiger auf Instanz der Klasse)
	HIGHLOW			timeStamp;		// Zeitmarke (64 Bit; 0.8 s Auflsung)
	DWORD			canIdentifier;
	unsigned long	lost;			// Verlorene Botschaften (zwischen der aktuellen und der zuletzt in der Applikation empfangenen)
	unsigned char	canRTR;			// ???
	unsigned char	canDLC;			
	unsigned char	status;			// Statusbyte aus SJL1000
	char			intern;			// 1=Karte wurde rckgesetzt (Spannung aus/ein)
	short			isrNummer;		// Nummer zum freigeben der Struktur nach Bearbeitung
	unsigned char	canMsg[8];		// eine CAN-Botschaft kann maximal 8 Bytes enthalten
};

//typedef void (WINAPI *isrCallback)(DWORD);

typedef struct InitISRFunctions
{
	DWORD		pCallback;
	DWORD		refData;
}INITISRFUNCTIONS;



typedef struct CanParInfo
{
	unsigned long	version;		// ActiveX und Treiber mssen zusammenpassen !! (Versionskontrolle)
	HIGHLOW			time;			// Zeitmarke (64-Bit Wert)
	unsigned char   card;			// 1=ELEKTOR parallel
	unsigned char   os;				// 1=Treiber fr Win9x
}CANPARINFO;
