// Eigene Statusergebnisse umsetzen in NT Meldungen (falls mglich)
#define NO_ERROR 0
#define ERROR_BUFFER_OVERFLOW -ENOMEM
#define ERROR_INVALID -EINVAL



// Debug-Ausgaben
//#define TRACE(__x__) {printk(KERN_INFO "CanPar: ");printk __x__; printk("\n");}
#define TRACE(__x__) 1?(void)0:printk __x__

//--------------------------------------------------------------------
typedef void *PVOID;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

typedef struct can_device 
{
	int open;	// 1=Treiber zur Zeit von einer Anwendung in Benutzung

	struct pardevice *can_device;	// diese Struktur wird von den parport_... Funktionen bentigt
	struct fasync_struct *async_queue;

	spinlock_t sja_lock;	// Spinlock zum synchronisieren der SJA1000 - Registerzugriffe
	unsigned long lock_flags;

	int      in_isr; // TRUE innerhalb der Interrupt-Routine

	unsigned short portTyp;	// siehe wr_can()
	unsigned char  statusport;      // SJA1000: Status-Port

	unsigned short ecp;         // 0=Bidirektional 1=ECP
	unsigned short pelican;		// 1=Pelican
	unsigned short eff;			// nur fr Sendevorgnge:
								// 0=Botschaft im "Standard Frame Format" senden
								// 1=Botschaft im "Extended Frame Format" senden 
	unsigned long baudrate;
	unsigned long access_code;
	unsigned long access_mask;
	int standby; // 1=SJA1000 befindet sich im Standby


	struct ISRInfo sendedaten;

	unsigned long   ISRReceive;
	unsigned long   ISRTransmit;
	unsigned long   ISRError;
	unsigned long   ISROverrun;
	unsigned long   ISRWakeUp;
	unsigned long   UsrReceive;
	unsigned long   UsrTransmit;
	unsigned long   UsrError;
	unsigned long   UsrOverrun;
	unsigned long   UsrWakeUp;
	
	int		 irq_allowed;

	
	struct  ISRInfo *admISRInfo;	// Daten, die an die USER-Mode Applikation bergeben werden (FIFO-Struktur)
	short   admISRAktuell;			// Nummer (Daten wurden in die Warteschlange eingereiht)
	long    admLostReceived;		// "verlorene" CAN Botschaften
	long    admISRFinished;			// Nummer (bis "hier" wurden die Daten bereits abgeholt)

	struct  ISRInfo *sndISRInfo;	// CAN-Botschaften in der Warteschlange, die noch an den SJA bergeben werden mssen (FIFO)
	short   sndISRAktuell;
	short   sndISRFinished;
	short   transmitting;			// 1=Daten wurden in das SJA1000 geschrieben, warte jetzt auf IRQ

	
	int     max_inOutBuffer;		// Die Pointer fr lpvInBuffer und lpvOutBuffer werden im Treiber dynamisch angelegt und bei Bedarf erhht
	PVOID	lpvInBuffer;			// Datenbergabe ber IOControl
	int		cbInBuffer;
	PVOID	lpvOutBuffer;
	int		cbOutBuffer;
	int		cbBytesReturned;

} CANDEVICE;
