#include <stdio.h>
#include "mcc.h"

void CGenericButton::Connect(void)
{
  gtk_signal_connect(GTK_OBJECT(m_pWindow),"enter",GTK_SIGNAL_FUNC(CS_ButtonEnter),this);
  gtk_signal_connect(GTK_OBJECT(m_pWindow),"leave",GTK_SIGNAL_FUNC(CS_ButtonLeave),this);
}

int CGenericButton::Create(CWindow *pParent, int Id, PCTSTR title, BOOL show)
{
  m_pParent = pParent;
  m_Id = Id;

  CreateButton(title);
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_container_add(GTK_CONTAINER(m_pParent->m_pWindow),m_pWindow);
  Connect();
  Show(show);    
  return 0;
}

int CGenericButton::Create(CPackBox *pParent, int Id, PCTSTR title, BOOL bExpand, 
                    BOOL bFill, int nPadding, BOOL show)
{
  m_pParent = pParent;
  m_Id = Id;

  CreateButton(title);
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_box_pack_start(GTK_BOX(m_pParent->m_pWindow),m_pWindow,bExpand,bFill,nPadding);
  Connect();
  Show(show);    
  return 0;
}

int CGenericButton::CreateFromEnd(CPackBox *pParent, int Id, PCTSTR title, BOOL bExpand, 
                    BOOL bFill, int nPadding, BOOL show)
{
  m_pParent = pParent;
  m_Id = Id;

  CreateButton(title);
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_box_pack_end(GTK_BOX(m_pParent->m_pWindow),m_pWindow,bExpand,bFill,nPadding);
  Connect();
  Show(show);    
  return 0;
}

int CGenericButton::Create(CPackTable *pParent, int Id, int nLeft, int nTop, int nRight, int nBottom, PCTSTR title, int nXopt, int nYopt, int nXpadding, int nYpadding, BOOL show)
{
  m_pParent = pParent;
  m_Id = Id;
  
  CreateButton(title);
  if (!m_pWindow) return -1;
  if (m_pParent) 
  {
    gtk_table_attach(GTK_TABLE(pParent->m_pWindow),m_pWindow,nLeft,nRight,nTop,nBottom,(GtkAttachOptions)nXopt,(GtkAttachOptions)nYopt,nXpadding,nYpadding);
  }

  Connect();
  Show(show);    
  return 0;
}

int CGenericButton::Create(CScrolledWindow *pParent, int Id, PCTSTR title, BOOL show)
{
  m_pParent = pParent;
  m_Id = Id;
  CreateButton(title);
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(m_pParent->m_pWindow),m_pWindow);
  Connect();
  Show(show);    
  return 0;
}


void CGenericButton::Enter(void)
{
  //TRACE("CButton::Enter\n");
}

void CGenericButton::Leave(void)
{
  //TRACE("CButton::Leave\n");
}

