#include <stdio.h>
#include "mcc.h"

int CMenuBar::Create(CWindow *pParent, BOOL show)
{
   m_pParent = pParent;
   m_pWindow = gtk_menu_bar_new();
   if (!m_pWindow) return -1;
   gtk_container_add(GTK_CONTAINER(pParent->m_pWindow),m_pWindow);
   Show(show);    
   return 0;
}

int CMenuBar::Create(CPackBox *pParent, BOOL bExpand, BOOL bFill, int nPadding, BOOL show)
{
  m_pParent = pParent;
   m_pWindow = gtk_menu_bar_new();
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_box_pack_start(GTK_BOX(m_pParent->m_pWindow),m_pWindow,bExpand,bFill,nPadding);
 // Connect();
  Show(show);    
  return 0;
}

int CMenuBar::CreateFromEnd(CPackBox *pParent, BOOL bExpand, BOOL bFill, int nPadding, BOOL show)
{
  m_pParent = pParent;
   m_pWindow = gtk_menu_bar_new();
  if (!m_pWindow) return -1;
  if (m_pParent) gtk_box_pack_end(GTK_BOX(m_pParent->m_pWindow),m_pWindow,bExpand,bFill,nPadding);
 // Connect();
  Show(show);    
  return 0;
}

int CMenuBar::Create(CPackTable *pParent, int nLeft, int nTop, int nRight, int nBottom, PCTSTR title, int nXopt, int nYopt, int nXpadding, int nYpadding, BOOL show)
{
  m_pParent = pParent;
  m_pWindow = gtk_menu_bar_new();
  if (!m_pWindow) return -1;
  if (m_pParent) 
  {
    gtk_table_attach(GTK_TABLE(pParent->m_pWindow),m_pWindow,nLeft,nRight,nTop,nBottom,(GtkAttachOptions)nXopt,(GtkAttachOptions)nYopt,nXpadding,nYpadding);
  }
  Show(show);    
  return 0;
}

void CMenuBar::Append(CMenu *menu)
{
   gtk_menu_bar_append(GTK_MENU_BAR(m_pWindow),menu->m_pWindow);
}

void CMenuBar::Append(CMenuItem *menu)
{
   gtk_menu_bar_append(GTK_MENU_BAR(m_pWindow),menu->m_pWindow);
}

int CMenu::Create(void)
{
   m_pWindow = gtk_menu_new();
   if (!m_pWindow) return -1;
   return 0;   
}

void CMenu::Append(CMenuItem *item)
{
   gtk_menu_append(GTK_MENU(m_pWindow),item->m_pWindow);
}
/*
void CMenuItem::Init(void)
{
	CWidget::Init();
	m_Id=0;
}
*/
int CMenuItem::Create(PCTSTR title, BOOL show=TRUE)
{
   m_Id = -1;
   m_pParent = NULL;
   m_pWindow = gtk_menu_item_new_with_label(title);
   if (!m_pWindow) return -1;
   Connect();
   Show(show); 
   return 0;   
}

int CMenuItem::Create(CWindow *window,PCTSTR title, int id, BOOL show=TRUE)
{
   m_Id = id;
   m_pParent = window;
   m_pWindow = gtk_menu_item_new_with_label(title);
   if (!m_pWindow) return -1;
   Connect();
   Show(show); 
   return 0;   
}

void CMenuItem::SetSubMenu(CMenu *menu)
{
   gtk_menu_item_set_submenu(GTK_MENU_ITEM(m_pWindow),menu->m_pWindow);
}

void CMenuItem::Connect(void)
{
  gtk_signal_connect(GTK_OBJECT(m_pWindow),"activate",GTK_SIGNAL_FUNC(CS_ButtonClick),this);
}

void CMenuItem::Click(void)
{
  //TRACE("CButton::Click Id=%d \n",m_Id);
  if (m_pParent)
  {
      m_pParent->Command(m_Id);
  }
}

int CCheckMenuItem::Create(PCTSTR title, BOOL show=TRUE)
{
   m_Id = -1;
   m_Checked = FALSE;
   m_pParent = NULL;
   m_pWindow = gtk_check_menu_item_new_with_label(title);
   if (!m_pWindow) return -1;
   gtk_check_menu_item_set_show_toggle(GTK_CHECK_MENU_ITEM(m_pWindow),TRUE);
   Connect();
   Show(show); 
   return 0;   
}

int CCheckMenuItem::Create(CWindow *window,PCTSTR title, int id, BOOL show=TRUE)
{
   m_Checked = FALSE;
   m_Id = id;
   m_pParent = window;
   m_pWindow = gtk_check_menu_item_new_with_label(title);
   if (!m_pWindow) return -1;
   gtk_check_menu_item_set_show_toggle(GTK_CHECK_MENU_ITEM(m_pWindow),TRUE);
   Connect();
   Show(show); 
   return 0;   
}

void CCheckMenuItem::Connect(void)
{
  gtk_signal_connect(GTK_OBJECT(m_pWindow),"toggled",GTK_SIGNAL_FUNC(CS_ButtonToggled),this);
}

void CCheckMenuItem::SetCheck(BOOL checked)
{
	m_Checked = checked;
	gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(m_pWindow),checked);
}

void CCheckMenuItem::Toggle(void)
{
  //TRACE(" CCheckMenuItem::Toggle %d %d %d\n",m_Id,m_Checked,GTK_CHECK_MENU_ITEM(m_pWindow)->active);
  if (GTK_CHECK_MENU_ITEM(m_pWindow)->active == (guint)m_Checked)
  {
  	//TRACE("CCheckMenuItem Callback wird nicht aufgerufen\n");
  	return;
  }
  m_Checked = (BOOL)GTK_CHECK_MENU_ITEM(m_pWindow)->active;
  if (m_pParent)
  {
      m_pParent->Command(m_Id);
  }
}


