#include <stdio.h>
#include "mcc.h"



CWidget::CWidget()
{
    //TRACE("CWidget::Init auf\n");
	m_StopCommandChain=FALSE;
	m_pWindow=NULL;
	m_pParent=NULL;
	m_Initialized = FALSE;
}
/*
CWidget::~CWidget()
{
//	Destroy();
}
*/
void CWidget::Destroy(void)
{
    //TRACE("CWidget Destruktor\n");
  	if (m_Initialized) 
  	{
  		m_Initialized = FALSE;
    	CloseWidget();
   	}
    if(m_pWindow && GTK_IS_WIDGET(m_pWindow)) 
    {
    	GtkWidget *tmp=m_pWindow;
    	m_pWindow = NULL;
    	gtk_widget_destroy(tmp);
    }
    m_pWindow = NULL;
    m_Initialized = FALSE;
    //TRACE("CWidget Destruktor -2-\n");
}

void CWidget::Connect(void)
{
	if(m_pWindow)
	{
		gtk_signal_connect(GTK_OBJECT(m_pWindow),"destroy_event",GTK_SIGNAL_FUNC(CS_Destroy),this);
	    gtk_signal_connect(GTK_OBJECT(m_pWindow),"delete_event",GTK_SIGNAL_FUNC(CS_Quit),this);
		//gtk_signal_connect(GTK_OBJECT(m_pWindow),"destroy_event",GTK_SIGNAL_FUNC(CS_Quit),this);
	}
}

int CWidget::SetMinimumSize(int Width, int Height)
{
    gtk_widget_set_usize(m_pWindow,Width,Height);
    return 0;
}

void CWidget::Show(BOOL show)
{
	if (!m_Initialized) 
	{
		InitWidget();
		m_Initialized = TRUE;
	}
	if (show)  gtk_widget_show(m_pWindow);
	else gtk_widget_hide(m_pWindow);
}

BOOL CWidget::Command(int Id)
{
  //TRACE("CWidget::Command %d %p %d\n",Id,m_pParent,m_StopCommandChain);
  if (m_pParent && !m_StopCommandChain)
  {
    return m_pParent->Command(Id);
  }
  return FALSE;
}

CSize CWidget::GetSize(void)
{
	CSize ret;
	GtkRequisition size;
	gtk_widget_size_request(m_pWindow,&size);
	ret = size;
	return ret;
}

void CWidget::SetSize(const CSize &s)
{
   	gtk_widget_set_usize(m_pWindow,s.width,s.height);
}

void CWidget::Enable(BOOL enable)
{
	gtk_widget_set_sensitive(m_pWindow,enable);
}
