#include <sys/ioctl.h>
#include "../canpar.h"

// Men Kommandos
enum
{
	IDM_QUIT=100,
	IDM_DRV_OPEN,
	IDM_DRV_CLOSE,
	IDM_BAUDRATE,
	IDM_ACCEPTANCE_CODE,
	IDM_MESSAGES,
	IDM_INFO,
	IDM_RESET_TIME,
	IDM_SHOW_DATA,
	IDM_GO_TO_SLEEP,
	IDM_CLEAR_OVR,
	IDM_ABORT_TRANSMISION,
};


class Geraet : public CDialog
{
   CComboBox liste;   // Gerte (CANPAR, CANPAR1, CANPAR2, ...)
   CButton ok;
   int num;
public:
   CComboBox typ; // 0=Basic Can  1=PeliCan
   CComboBox identifier;// 0=SFF 1=EFF
   Geraet(){num=0;}

   BOOL		Command(int Id);
   void InitWidget();
   void CloseWidget();
};

class CanAccess : public CDialog
{
   CButton ok;
   CEntryWidget mask,code;
   CPackBox p1,p2;
   CLabel l1,l2;
public:
   unsigned long m_Mask;
   unsigned long m_Code;
   
   CanAccess(){m_Mask=0xffffffff;m_Code=0xffffffff;}

   BOOL		Command(int Id);
   void InitWidget();
   void CloseWidget();
};

class Baudrate : public CDialog
{
	CEntryWidget baud;
	CButton ok;
	
public:
    long m_Wert;
    void InitWidget();
    void CloseWidget();
    BOOL Command(int);
};

class MyWindow;
class Botschaften : public CDialog
{
public:
	CPackTable table;
	CEntryWidget b1,b2,b3,b4,b5;
	CEntryWidget c1,c2,c3,c4,c5;
	CEntryWidget zeit;
	CLabel l1,l2,l3,l4,l5;
	CButton ok;
	CButton senden,abbrechen,start,stop;
	CCheckButton s1,s2,s3,s4;

	MyWindow *hauptfenster;
	BOOL SendeDatenZeileX(CEntryWidget *id, CEntryWidget *dat, CCheckButton *mark);
	BOOL SendeDaten(void);
	BOOL SendDatenAusThread();
	
    void InitWidget();
    void CloseWidget();
    BOOL Command(int);
};

class MyWindow : public CWindow
{
  CScrolledWindow scrwin;
  CPackBox box;
  CPackTable table;
  CList b8;
  CButton b3;
  CComboBox xxx;
  CMenuBar mn;
  CMenu mdatei,mconfig,mhilfe;
  CMenuItem datei,config,hilfe;
  CMenuItem beenden;
  CMenuItem oeffnen,schliessen,baudrate,botschaften,acceptance,reset_time,go_to_sleep,clear_ovr,abort_trans;
  CCheckMenuItem show_data;
  CMenuItem info;

  long m_Baudrate;
  long m_DataLost;
  BOOL m_ShowMessages;
  unsigned long m_Mask;
  unsigned long m_Code;
  

public:
	int m_pid;	// PID des Arbeitsproze
	Botschaften m_Botschaften;
    unsigned long m_oldTime;		// Zur Berechnung der Differenz zwischen zwei Botschaften
    unsigned long m_startTime;	// Startzeit (wird in OpenCan() festgestellt)
    volatile int ready;
//  	int thread_loop;
//  	long m_thread_time;
//  	int m_file;
//  	struct CanParInfo m_info;

  	
  	MyWindow();
  
	void StartThread(void);
	void StopThread(void);
	int  CANClose();
	int  CANOpen();
	void OnBaudrateChanged();
	void OnAcceptanceCode_Mask();
	int Transmit(long id, short rtr, short dlc, unsigned char *data); 
	int GoToSleep();
	int ClearDataOverrun();
	int AbortTransmission(); 
	int ResetTime();
	void xFireCANReceived(struct ISRInfo *msg);
	void xFireCANTransmitted(struct ISRInfo *msg);
	void xFireCANError(struct ISRInfo *msg);
	void xFireCANWakeUp(struct ISRInfo *msg);
	void xFireCANOverrun(struct ISRInfo *msg);
	//int ConvertString(unsigned char *ziel, int max, const char *quelle);
	BOOL TransmitData(long id, short rtr, const char *data); 
	void AddDataToListe(void);
  	BOOL Command(int Id);
  	void InitWidget();
  	void CloseWidget();
};
